// lZONXQiSŁj

#ifndef ___Math_Exception
#define ___Math_Exception

#include <string>
#include <cstring>
#include <sstream>
#include <exception>
#include <stdexcept>

//--- lZɂO ---//
class MathException : public std::logic_error {
public:
	// RXgN^
	MathException() : logic_error("lZO") { }

	virtual const char* what() const { return "lZO"; }
};

//--- 0ɂ鏜Z ---//
class DividedByZero : public MathException {
public:
	const char* what() const { return "Oɂ鏜Z"; }
};

//--- I[ot[ ---//
class Overflow : public MathException {
	int v;		// Z
public:
	Overflow(int val) : v(val) { }

	int value() const { return v; }

	const char* what() const {
		static char buff[128];		// ԋp镶̈
		std::ostringstream s;
		s << "I[ot[il" << v << "j";
		return std::strcpy(buff, s.str().c_str());
	}
};

//--- A_t[ ---//
class Underflow : public MathException {
	int v;		// Z
public:
	Underflow(int val) : v(val) { }

	int value() const { return v; }

	const char* what() const {
		static char buff[128];		// ԋp镶̈
		std::ostringstream s;
		s << "A_t[il" << v << "j";
		return std::strcpy(buff, s.str().c_str());
	}
};

#endif
