// 7 ܂Ƃ߂̃vO

#include <string>
#include <iostream>

using namespace std;

//--- FNX ---//
class Color {
public:
	enum { RED,  GREEN, BLUE };		// F

	virtual ~Color() = 0;						// zfXgN^
	virtual void change_color(int color) = 0;	// FύX
};

inline Color::~Color() { }						// zfXgN^


//--- EFAuNX ---//
class Wearable {
public:
	virtual ~Wearable() = 0;			// zfXgN^
	virtual void put_on() = 0;			// 
	virtual void put_off() = 0;			// E
};

inline Wearable::~Wearable() { }		// zfXgN^


//--- EFAuRs[^NX ---//
class WearableComputer : public Wearable {
	std::string name;	// O
public:
	WearableComputer(std::string n) : name(n) { }

	virtual void put_on()  { std::cout << name << " ON!!\n"; }
	virtual void put_off() { std::cout << name << " OFF!!\n"; }
};


//--- EFAu{bgNX ---//
class WearableRobot : public Color, public Wearable {
	int color;	// F
public:
	WearableRobot(int c) : color(c) { }

	void change_color(int color) { this->color = color; }

	std::string to_string() {
		switch (color) {
		 case Color::RED:   return "ԃ{bg";
		 case Color::GREEN: return "΃{bg";
		 case Color::BLUE:  return "{bg";
		}
	}

	void put_on()  { std::cout << to_string() << " !!\n"; }
	void put_off() { std::cout << to_string() << " !!\n"; }
};


int main()
{
	Wearable* w[] = {
		new WearableComputer("HAL"),	// Rs[^
		new WearableRobot(Color::RED),	// ԃ{bg
		new WearableRobot(Color::BLUE),	// {bg
	};

	for (int i = 0; i < sizeof(w) / sizeof(w[0]); i++) {
		w[i]->put_on();
		w[i]->put_off();
	}

	for (int i = 0; i < sizeof(w) / sizeof(w[0]); i++)
		delete w[i];
}

